diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/tmpmenu.py sketch1/Sketch/UI/tmpmenu.py
--- sketch.orig/Sketch/UI/tmpmenu.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/tmpmenu.py	2005-03-19 22:29:18.000000000 +0100
@@ -0,0 +1,351 @@
+# This is a temporary solution to provide the menu infrastructure
+# which is needed by some of the panels. It is quickly pasted together
+# from several files. 
+
+
+from types import StringType, TupleType
+
+import gtk
+
+import Sketch.Editor
+from Sketch.Base import Publisher, const
+
+from command import Command
+
+import skapp
+
+# Map sketch command names to gtk stock ids. The stock ids will be used
+# to create menu items with stock items.
+stock_item_map = {
+    "file_new": "gtk-new",
+    "file_open": "gtk-open",
+    "file_save": "gtk-save",
+    "file_save_as": "gtk-save-as",
+    "cut_selected": "gtk-cut",
+    "copy_selected": "gtk-copy",
+    "paste_clipboard": "gtk-paste",
+    "exit": "gtk-quit",
+    "undo": "gtk-undo",
+    "redo": "gtk-redo",
+    "delete": "gtk-delete",
+    "zoom_100": "gtk-zoom-100",
+    "zoom_in": "gtk-zoom-in",
+    "zoom_out": "gtk-zoom-out",
+}
+
+class SketchMenuItem:
+
+    def __init__(self, command, context, accel, stroke = ''):
+        self.command = command
+        self.context = context
+        self.activate_id = self.connect("activate", self.call_command)
+        self.subscribe()
+        if stroke:
+            key, mods = stroke
+            self.add_accelerator("activate", accel, key, mods, 'visible')
+        # FIXME: Handle user changes to the accelerator. In PyGTK
+        # 0.6/GTK1.2 this was done with these events:
+        # self.connect('add-accelerator', self.accel_added)
+        # self.connect('remove-accelerator', self.accel_removed)
+
+    def subscribe(self):
+        for channel in self.command.channels:
+            self.context.Subscribe(channel, self.changed)
+        self.context.Subscribe(Sketch.Base.const.CHANGED, self.changed)    
+        self.changed()
+
+    def changed(self, *args):
+        self.set_sensitive(self.command.Sensitive(self.context))
+        if self.command.HasDynText():
+            text = self.command.DynText(self.context)
+            if text:
+                self.get_child().set_text(text)
+                self.show()
+            else:
+                self.hide()
+
+    def call_command(self, widget):
+        self.command.Execute(self.context)
+
+    def accel_added(self, item, signalid, accel, key, mod, flags):
+        skapp.keymap.AddItem(self.command.Name(), (key, mod))
+
+    def accel_removed(self, item, accel, key, mod):
+        skapp.keymap.RemoveItem((key, mod))
+
+class SketchMenuCommand(SketchMenuItem, gtk.ImageMenuItem):
+
+    def __init__(self, command, context, accel, stroke = '',
+                 stock_id = ""):
+        """Initialize the SketchMenuCommand
+
+        If the stock_id parameter is given it should be the gtk stock id
+        to use when initializing the GtkImageMenuItem.
+        """
+        if stock_id:
+            gtk.ImageMenuItem.__init__(self, stock_id = stock_id)
+        else:
+            gtk.ImageMenuItem.__init__(self)
+            label = gtk.AccelLabel(command.Title())
+            label.set_alignment(0.0, 0.5)
+            label.show()
+            self.add(label)
+        SketchMenuItem.__init__(self, command, context, accel, stroke = stroke)
+
+class SketchMenuCheck(SketchMenuItem, gtk.CheckMenuItem):
+
+    def __init__(self, command, context, accel, stroke = ''):
+        gtk.CheckMenuItem.__init__(self, command.Title())
+        SketchMenuItem.__init__(self, command, context, accel, stroke)
+
+    def changed(self):
+        SketchMenuItem.changed(self)
+        checked = self.command.Checked(self.context)
+        active = self.active
+        if checked and not active or not checked and active:
+            self.handler_block(self.activate_id)
+            self.set_active(checked)
+            self.handler_unblock(self.activate_id)
+
+
+#
+# Class MenuMixin
+#
+#
+# We distinguish between menudata and the actual graphical
+# representation of a menu. Several menues can share the same menu
+# data tree. When the data changes they are automatically updated. The
+# MenuMixin connects to the data tree and provides the updating
+# mechanism. Derived Menues have to implement the methods "clear" and
+# "append". 
+
+
+class MenuMixin:
+    def __init__(self, context, data=None, keymap = None, accel = None,
+                 allow_tearoff = 1):
+        self.context = context
+        if keymap is None:
+            keymap = Sketch.UI.skapp.keymap
+        self.keymap = keymap
+        
+        self.allow_tearoff = allow_tearoff
+        if accel is None:
+            accel = gtk.AccelGroup()
+        self.accel = accel
+        if data is not None:
+            self.set_menudata(data)
+            
+    def set_menudata(self, data):
+        self.data = data
+        data.Subscribe(Sketch.Base.const.CHANGED, self.rebuild)
+        self.build_menu()
+        
+    def rebuild(self):
+        print "menu changed", self.data.name, id(self)
+        self.clear()
+        self.build_menu()
+        
+    def build_menu(self):
+        if self.allow_tearoff:
+            menuitem = gtk.TearoffMenuItem()
+            menuitem.show()
+            self.append(menuitem)
+
+        last = None
+        for item in self.data.Items():
+            if item is None and last is None:
+                continue
+            ok = self.append_menu_item(self, item)
+            if ok:
+                last = item
+
+    def append_menu_item(self, menu, item, show=1):        
+        # the return value indicates whether in item was appended
+        # (1 --> success) or not (0 --> failed)
+        accel = self.accel
+        keymap = self.keymap
+        context = self.context
+        
+        stroke = ()
+
+        if isinstance(item, StringType):
+            #item = Sketch.Editor.Registry.Menu(item) or \
+            #       Sketch.Editor.Registry.Command(item)
+            item = Sketch.Editor.Registry.Command(item)
+            if item is None:
+                #print "warning: command '%s' not found" % item
+                return 0
+                
+        if item is None:
+            # a separator            
+            menuitem = gtk.MenuItem()            
+        elif isinstance(item, Command):
+            # a command
+            if keymap is not None:
+                stroke = keymap.Keystroke(item)
+            if item.IsCheckCommand():
+                menuitem = SketchMenuCheck(item, context, accel, stroke)
+            else:
+                stock_id = stock_item_map.get(item.Name(), "")
+                menuitem = SketchMenuCommand(item, context, accel, stroke,
+                                             stock_id = stock_id)
+        else:
+            # must be a submenu
+            item.Subscribe(Sketch.Base.const.CHANGED, self.rebuild)
+            
+            submenu = gtk.Menu()
+            if self.allow_tearoff:
+                menuitem = gtk.TearoffMenuItem()
+                menuitem.show()
+                submenu.append(menuitem)
+
+            last = None
+            for subitem in item.Items():                
+                if subitem is None and last is None:
+                    continue
+
+                if self.append_menu_item(submenu, subitem, show):
+                    last = subitem
+                
+            menuitem = gtk.MenuItem(item.Title())
+            menuitem.set_submenu(submenu)
+        
+        if show:
+            menuitem.show()
+        menu.append(menuitem)
+
+        return 1
+
+    def clear(self):
+        """Remove all gtk menu entries. Must be provided by deried class."""
+        raise "not implemented"
+
+    def append(self, menuitem):
+        """Append an entry to a gtk menu. Must be provided by derived class."""
+        raise "not implemented"
+
+
+#
+# A drop-down menu
+#
+class SketchMenu(gtk.Menu, MenuMixin):
+    def __init__(self, *args, **kw):
+        gtk.Menu.__init__(self)
+        apply(MenuMixin.__init__, (self,)+args, kw)
+        
+    def clear(self):
+        for widget in self.get_children():
+            self.remove(widget)
+    
+#
+# A menu bar
+#
+class SketchMenuBar(gtk.MenuBar, MenuMixin):
+    def __init__(self, *args, **kw):
+        gtk.MenuBar.__init__(self)
+        kw['allow_tearoff'] = gtk.FALSE
+        apply(MenuMixin.__init__, (self,)+args, kw) 
+
+    def clear(self):
+        for widget in self.get_children():
+            self.remove(widget)
+
+class MenuNode(Publisher):
+    """Baseclass for menu nodes."""
+    
+    def __init__(self, name, title, translatable = 0):
+        self.name = name
+        self.title = title
+        self.translatable = translatable
+
+    def changed(self):
+        self.issue(const.CHANGED)
+
+    def Title(self):
+        if self.translatable:
+            return _(self.title)
+        else:
+            return self.title
+
+    def Items(self):
+        return ()
+
+
+class ListMenu(MenuNode):
+    
+    def __init__(self, *args, **kw):
+        apply(MenuNode.__init__, (self,)+args, kw)
+        self.items = []
+        
+    def Items(self):
+        return self.items
+
+    def AppendItem(self, item):        
+        self.items.append(item)
+        self.changed()
+
+    def RemoveItem(self, item):
+        self.items.remove(item)
+        self.changed()
+
+class Menu(ListMenu):
+
+    def Submenu(self, title):
+        for item in self.items:
+            # access title directly to avoid translation:
+            if isinstance(item, Menu) and item.title == title: 
+                return item
+        return None
+
+    def AddItem(self, path, item):
+        menu = self
+        if path:
+            if isinstance(path, StringType):
+                path = (path,)
+            for title in path:
+                submenu = menu.Submenu(title)
+                if submenu is None:
+                    submenu = Menu('', title)
+                    menu.AppendItem(submenu)
+                menu = submenu
+        menu.AppendItem(item)
+
+def build_menu_tree(name, title, description, registry, translatable = 1):
+    """Build a menu tree from a description table.
+
+    The syntax of the description in EBNF is:
+    
+      description = [descr] | menu_data
+      descr = None | command_name | command | menu_name | menu_tree |
+              (name,description)
+
+    None gives a separator, command_name or menu_name will be looked
+    up in the registry, command is directly a command.
+    """
+
+    if isinstance(description, MenuNode):
+        menu = MenuNode(name, title, translatable)
+        for item in description.Items():
+            menu.AppendItem(item)
+        return menu
+
+    menu = Menu(name, title, translatable)
+    
+    for descr in description:
+        if isinstance(descr, StringType):
+            item = descr
+        elif descr is None:
+            item = descr
+        elif isinstance(descr, MenuNode):
+            item = descr
+        elif isinstance(descr, Command):
+            item = descr
+        else:
+            _title, _descr = descr
+            item = build_menu_tree('', _title, _descr, registry, 1)
+        menu.AppendItem(item)
+    return menu
+
+
+def BuildMenuTree(name, title, description):
+    return build_menu_tree(name, title, description, Sketch.Editor.Registry)
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/toolbox.py sketch1/Sketch/UI/toolbox.py
--- sketch.orig/Sketch/UI/toolbox.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/toolbox.py	2005-03-19 20:27:08.000000000 +0100
@@ -157,7 +157,7 @@
         # writers, so it should at least require a config-flag.
         descr = ['message_panel', 'reload_panel',
                  None, 'property_panel', 'fill_panel', 'meta_panel',
-                 'palette_panel', 'object_panel']
+                 'palette_panel', 'object_panel', 'inspector_panel']
         tree = Sketch.Editor.BuildMenuTree('<toolbox>', descr)
         return menu.make_menu(tree, None, self.context)
 
